#include<lpc214x.h>	   // LPC2148 MPU Register
// Define LCD PinIO Mask 
#define  LCD_RS     (1<<17)   						
#define  LCD_EN     (1<<19)   						

#define  LCD_D4     (1<<20)   						
#define  LCD_D5     (1<<21)  						
#define  LCD_D6     (1<<22)  						   
#define  LCD_D7     (1<<23)  
						
///////////////////////  LCD Command Sending Function/////////////////////
extern lcdcmd(unsigned char val)
{
 unsigned int lcd_ch;			   // LCD Initial Data 
 unsigned int lcd_i;			   // LCD Initial Delay Count 

 IOCLR1 = LCD_RS ;					// RS = 0 
 
 lcd_ch=((val>>4)&0x0F);			// Strobe 4-Bit High-Nibble to LCD

 IOCLR1 = (LCD_D7|LCD_D6|LCD_D5|LCD_D4);	 // Reset 4-Bit Pin Data
 IOSET1 = (lcd_ch<<20); 			    	// Data Send to Respective Pins    
 IOSET1 = LCD_EN ;					// EN = 1 (Enable)
 for (lcd_i=0;lcd_i<10000;lcd_i++);	//delay
 IOCLR1 = LCD_EN ;					// EN = 0 (Disable)	
  
 lcd_ch=(val&0x0F);				  		// Strobe 4-Bit Low-Nibble to LCD

 IOCLR1 = (LCD_D7|LCD_D6|LCD_D5|LCD_D4); // Reset 4-Bit Pin Data
 IOSET1 = (lcd_ch<<20); 				// EN,0,RW,RS:DDDD:0000:0000:0000:0000:0000:0000   
 IOSET1 = LCD_EN ;					// EN = 1 (Enable)
 for (lcd_i=0;lcd_i<10000;lcd_i++);	//delay
 IOCLR1 = LCD_EN ;					// EN = 0 (Disable)	
  
 for (lcd_i=0;lcd_i<10000;lcd_i++);	 //delay
}

///////////////////////LCD Single Charecter Display Function/////////////////////////////////////////
extern lcddata(unsigned char val)
{
 unsigned int lcd_ch;		   // LCD Initial Data 
 unsigned int lcd_i;		   // LCD Initial Delay Count 

 IOSET1 = LCD_RS ;	 		// RS = 1 
 
 lcd_ch=((val>>4)&0x0F);	// Strobe 4-Bit High-Nibble to LCD

 IOCLR1 = (LCD_D7|LCD_D6|LCD_D5|LCD_D4); // Reset 4-Bit Pin Data
 IOSET1 = (lcd_ch<<20); 				 // Data Send to Respective Pins  
 IOSET1 = LCD_EN ;					// EN = 1 (Enable)
 for (lcd_i=0;lcd_i<10000;lcd_i++);	// delay
 IOCLR1 = LCD_EN ;					// EN = 0 (Disable)	
  
 lcd_ch=(val&0x0F);				  	// Strobe 4-Bit Low-Nibble to LCD

 IOCLR1 = (LCD_D7|LCD_D6|LCD_D5|LCD_D4); // Reset 4-Bit Pin Data
 IOSET1 = (lcd_ch<<20); 				 // Data Send to Respective Pins   
 
 IOSET1 = LCD_EN ;					// EN = 1 (Enable)
 for (lcd_i=0;lcd_i<10000;lcd_i++);	//delay
 IOCLR1 = LCD_EN ;					// EN = 0 (Disable)	
  
 for (lcd_i=0;lcd_i<10000;lcd_i++);	 //delay
}


///////////////////// LCD String Display Function ///////////////////
extern msgdisplay(unsigned char *str)
{
 while(*str)				   // Cheack Data is there or not
 lcddata(*str++);			  //LCD Single Charecter Display Function
}

/////////////////  LCD Initialization Function   ////////////////////
extern lcd_init(void)
{
 unsigned int lcd_main_i;			// LCD Initial Delay Count 

 PINSEL2 |= 0x00000000;				// GPIO1[31..16] = I/O Function
 //IODIR1  |= 0x003F0000 ;		    // GPIO1[21..16] = OUT Direction
 IODIR1   |= 0x0A0000 ;			               // LCD Data Bus = Write								
 IODIR1   |= 0x0F00000 ;

 					
 for (lcd_main_i=0;lcd_main_i<20000;lcd_main_i++);		    // Power-On Delay (15 mS)

 IOCLR1 = ((LCD_D7|LCD_D6|LCD_D5|LCD_D4|LCD_RS|LCD_EN));	// Reset (RS,EN,4-Bit Data) Pin
 IOSET1 = (LCD_D5|LCD_D4);			// Set D4,D5
 //delay(1000);
 IOSET1 = LCD_EN ;					// EN = 1 (Enable)
 for (lcd_main_i=0;lcd_main_i<10000;lcd_main_i++);			// Delay 
 IOCLR1 = LCD_EN ;					// EN = 0 (Disable)	
 for (lcd_main_i=0;lcd_main_i<10000;lcd_main_i++);	        // Delay 


 IOCLR1 = ((LCD_D7|LCD_D6|LCD_D5|LCD_D4|LCD_RS|LCD_EN));	// Reset (RS,EN,4-Bit Data) Pin
 IOSET1 = (LCD_D5|LCD_D4);			// Set D4,D5					
 IOSET1 = LCD_EN ;					// EN = 1 (Enable)
 for (lcd_main_i=0;lcd_main_i<10000;lcd_main_i++);			// Delay 
 IOCLR1 = LCD_EN ;					// EN = 0 (Disable)	
 for (lcd_main_i=0;lcd_main_i<10000;lcd_main_i++);	        // delay 
  
 IOCLR1 = ((LCD_D7|LCD_D6|LCD_D5|LCD_D4|LCD_RS|LCD_EN));	// Reset (RS,RW,EN,4-Bit Data) Pin
 IOSET1 = (LCD_D5|LCD_D4);			// Set D4,D5 
 IOSET1 = LCD_EN ;					// EN = 1 (Enable)
 for (lcd_main_i=0;lcd_main_i<10000;lcd_main_i++);		    // Delay 
 IOCLR1 = LCD_EN ;					// EN = 0 (Disable)	
 for (lcd_main_i=0;lcd_main_i<10000;lcd_main_i++);		    // Delay 			  
 
 IOCLR1 = ((LCD_D7|LCD_D6|LCD_D5|LCD_D4|LCD_RS|LCD_EN));	// Reset (RS,RW,EN,4-Bit Data) Pin
 IOSET1 = (LCD_D5);					// Set D4,D5 
 IOSET1 = LCD_EN ;					// EN = 1 (Enable)
 for (lcd_main_i=0;lcd_main_i<10000;lcd_main_i++);			// Delay 
 IOCLR1 = LCD_EN ;					// EN = 0 (Disable)	
 for (lcd_main_i=0;lcd_main_i<10000;lcd_main_i++);		    // Delay 
 			
 lcdcmd(0x28);    // LCD 4-Bit Mode
 lcdcmd(0x0c);    // LCD Courser Blinking Stop
 lcdcmd(0x06);    // LCD Shift Display Right
 lcdcmd(0x01);	   // LCD Clear Display
 for (lcd_main_i=0;lcd_main_i<10000;lcd_main_i++);		// Wait Command Ready		
}

extern convert(unsigned int k)
{
unsigned char d[10],i=0;

 
while(k>0)
{
  d[i]=k%10;
  k=k/10;
  i=i+1;
}


while(i>0)
{
  lcddata(d[i-1]+48);
  i=i-1;
}

}





 


